
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《淘宝技术这十年》读书笔记 (二).Java时代的脱胎换骨和坚若磐石 / 憋错料</title>

    <meta name="description" content="《淘宝技术这十年》读书笔记 (二).Java时代的脱胎换骨和坚若磐石 马云说过&quot;一个好的东西往往是是说不清楚的&quot;,姑且不论这句话的对与错.但我真的很佩服&lt;淘宝技术这十年&gt;这本书的作者子柳,能够通过淘宝的一些故事,按照时间顺序和IT发展的各种技术描述清楚,而且过程中读起来非常有意思. 该读书笔记中参杂了很多原文的知识,因为我实在无法割舍,都挺有意思的:同时记录一些有用的知识,通过这本书能介绍些学过的知识或面试中可能出现的题目及作者所思,文章还是非常有趣的,希望对大家有所帮助! 一. Java时代 脱胎换骨 我的师傅黄裳曾经说过&quo ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">《淘宝技术这十年》读书笔记 (二).Java时代的脱胎换骨和坚若磐石</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>马云说过“一个好的东西往往是是说不清楚的”，姑且不论这句话的对与错。但我真的很佩服《淘宝技术这十年》这本书的作者子柳，能够通过淘宝的一些故事，按照时间顺序和IT发展的各种技术描述清楚，而且过程中读起来非常有意思。</p>
<p>该读书笔记中参杂了很多原文的知识，因为我实在无法割舍，都挺有意思的；同时记录一些有用的知识，通过这本书能介绍些学过的知识或面试中可能出现的题目及作者所思，文章还是非常有趣的，希望对大家有所帮助！</p>
<h2>一.&nbsp;<strong>Java时代 脱胎换骨</strong></h2>
<p>我的师傅黄裳曾经说过“好的架构图充满美感”。一个架构好不好，从审美的角度就能看出来；后来我看了很多系统的架构，发现这个言论基本成立。反观淘宝以前两个版本的架构，如下图所示，你看哪个比较美？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNDUxMTM1MjM=.jpg">&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNDUxNTcyNTA=.jpg"></p>
<p>显然第一个比较好看，第二个显得头重脚轻，这也注定了它不是一个稳定的版本，只存活了不到半年的时间。2004年初，SQLRelay的问题解决不了（不能总这样通过不断地重启保证系统的稳定性），数据库必须要用Oracle，那么从哪里动刀呢？只有换开发语言了。换什么语言好？用Java。</p>
<p>Java是当时最成熟的网站开发语言，它有比较良好的企业开发框架，被世界上主流的大规模网站普遍采用。另外，有Java开发经验的人才也比较多，后续维护成本会比较低。</p>
<p>到2004年上半年，淘宝网已经运行了一年的时间，这一年积累了大量的用户，也快速开发了很多功能，当时这个网站已经很庞大了，而且新的需求还在源源不断地增加。把一个庞大的网站的开发语言换掉无异于脱胎换骨。在换的过程中还不能拖慢业务的发展，这无异于边换边跑，对时间和技术能力的要求都非常高。</p>
<p>做这样的手术，需要请第一流的专家来主刀，现在再考一下大家：亲，如果你在这个创业团队中，请什么样的人来做这件事呢？</p>
<p>PS：我的想法是请多隆，不是说“有困难找多隆”吗？他就相当于武侠小说中的扫地僧，也是淘宝的“神”。但他可能也需要自己学习吧！所以这样的答案也是不正确的，《淘宝技术这十年》读书笔记最后一篇博客我也将介绍淘宝网众多的大牛，其中第一位就是多隆。顺便说说，大家知道马云最喜欢的金庸小说里的人物是谁吗？没错，他就是风清扬。当时看到一个新闻，说马云想出演《笑傲江湖》风清扬一角色，找了很多关系，最后还是被导演无情的拒绝了，不知道消息是否真实，但确实挺有意思的！</p>
<p>我们的答案是请Sun公司的人。没错，就是创造Java语言的那家公司，世界上没有比他们更懂Java的了。除此之外，还有一个不为人知的原因，我刚才说到Java被世界上主流的大规模网站普遍采用，其中有一个网站就是eBay，那时eBay的系统刚刚从C&#043;&#043;改到Java，而且就是请Sun的工程师改造成Java架构的，这下你懂了吧？他们不仅更懂Java，而且更懂eBay。</p>
<p>Sun公司的这帮工程师的确很强大，在笔者2004年年底淘宝的时候，他们还在，我有幸与他们公事了几个月。现在摆在他们面前的问题是用什么办法把一个庞大的网站从PHP语言迁移到Java?而且要求在迁移过程中不停止服务，原来系统的bugfix和功能改进不受影响。亲，你是架构师你怎么做？</p>
<p>有人的答案是写一个翻译器，如同把中文翻译成英文一样，自动翻译（现在机器翻译是自然语言处理的重要应用）。我只能说你这个想法太超前了，“too young,too simple, sometimes native”。当时没有，现在也没有人能做到。</p>
<p>他们的大致方案是给业务分模块，一个模块一个模块地渐进式替换。如用户模块，老的member.taobao.com继续维护，不添加新功能，新功能在新的模块上开发，跟老的模块共用一个数据库，开发完毕之后放到不同的应用集群上，另开一个域名member1.taobao.com，同时在替换老的功能；替换一个，就把老的模块上的功能关闭一个，逐渐把用户引导到member1.taobao.com，等所有的功能都替换完之后，关闭member.taobao.com。</p>
<p>从设计上来看，这个member1的二级域名应该是一个过渡状态，但我们把member域名的代码下线以后，发现很难把member1切换回member，因为有些地方把链接写死了，于是后来很长时间里我们都在用member1.taobao.com这个奇怪的域名。一年之后，有另一家互联网公司开始做电子商务，他们的域名也叫member1.xx.com、auction1.xx.com，复制得毫无保留，我们只能会心一笑。</p>
<h2><strong>二.&nbsp;</strong>MVC框架</h2>
<p>说了开发模式，再说说用到的Java MVC框架。当时struts1.x是用得比较多的框架，但是用过webwork和struts2的人可能知道，struts1.x在多人协作方面有很多致命的弱点。由于没有一个轻量框架作为基础，因此很难扩展，这样架构师对于基础功能和全局功能的控制就很难做到。</p>
<p>而阿里巴巴的18个创始人中有个架构师周悅虹，他在Jakarta Turbine的基础上做了很多扩展，打造另一个阿里巴巴自己用的MVC框架WebX：</p>
<p><a href="http://www.openwebx.org/docs/Webx3_Guide_Book.html" rel="external nofollow noreferrer">http://www.openwebx.org/docs/Webx3_Guide_Book.html</a></p>
<p>这个框架易于扩展，方便组件化开发，它的页面模板支持JSP和Velocity等，持久层支持ibatis和hibernate等，控制层可以用EJB和Spring（Spring是后来才有的）。项目组选择了这个强大的框架。</p>
<p>另外，当时Sun在全世界大力推广他们的EJB，虽然淘宝的架构师认为这个东西用不到，但他们还是极力坚持。在经历了很多次的技术讨论、争吵之后，这个系统的架构就变成了下图的形式。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTA2NDY2Nzk=.jpg"></p>
<p>MVC框架是阿里的WebX，控制层用了EJB，持久层是ibatis。另外为了缓解数据库的压力，商品查询和店铺查询放在搜索引擎中。这个架构图是不是好看了一点？</p>
<p>Sun的这帮工程师开发淘宝网后，用同样的架构又做了一个很牛的网站，叫“支付宝”。（上一篇说过支付宝最初是淘宝的“安全交易”功能，这个功能后来独立出来，成立了一个网站，也成立了一个公司，就是现在的支付宝。把支付宝从淘宝分出去的人，就是Sun公司的这几个人。）下图是支付宝第一次员工大会。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTE5NTc4ODc=.jpg"></p>
<p>上面的结构中，引入了搜索引擎iSearch（它是在LAMP[Linux&#043;Apache&#043;MySQL&#043;PHP]系统运行一段时间之后被多隆引进的，换为Oracle之后知识替换一下数据源）。其实这个搜索引擎的原理很简单，就是把数据库里的数据dump（倾倒）成结构化的文本文件后，放在硬盘上，提供Web应用以约定的参数和语法来查询这些数据。</p>
<p>这看起来不难，难的是数以亿计的信息，怎么做到快速更新呢？这好比你做了一个网站，在百度上很快就能搜到，你一定很满意了。但是如果你发布一件商品，在淘宝上过了1个小时还搜不到，你肯定很郁闷。另一个难点是如何保证非常高的容量和并发量？再往后面就要考虑断句和语义分析的问题，以及推荐算法等更加智能的问题。这些内容先不详细介绍，因为搜索引擎的技术已经足以写好几本书了。</p>
<p>其实在任何时候，开发语言本身都不是系统的瓶颈，业务带来的压力更多的存在于数据和存储方面。前面也说到，MySQL撑不住之后换位Oracle，Oracle的存储一开始在本机上，后来在NAS上，NAS撑不住了用EMC的SAN存储，再后来，Oracle的RAC撑不住了，数据的存储方面就不得不考虑使用小型机。在2004年夏天，DBA七公、测试工程师郭芙和架构师行癫，踏上了去北京测试小型机的道路。他们带着小型机回来的时候，然后Oracle就运行在小型机上；存储方面，从EMC低端CX存储到Sun<br />
 oemhds高端存储，再到EMC dmx高端存储，一级一级地往上跳。</p>
<p>到2004年底，淘宝网已经有4百多万种商品了，日均4千多万个PV，注册会员达到400万个，全网成交额达10亿元。</p>
<p>到现在为止，我们已经用上了IBM的小型机、Oracle的数据库、EMC的存储，这些东西都是很贵的。有人说过“钱能解决的问题，就不是问题”，但随着淘宝网的发展，在不久以后，钱已经解决不了我们的问题了。花钱买豪华的配置，也许能支持1亿个PV的网站，但淘宝网的发展太快，到了10亿个PV怎么办？到了百亿怎么办？</p>
<p>在几年以后，我们不得不创造技术，解决这些只有世界顶尖的网站才会遇到的问题。后来我们在开源软件的基础上进行自主研发，一步步把IOE（IBM小型机、Oracle、EMC存储）这几个“神器”都去掉了。这些神器就如同《西游记》中那些神仙的兵器，他们身边的妖怪们拿到这些兵器能把猴子打得落荒而逃。但最牛的神仙不依赖这些神器，他们挥一挥衣袖、翻一下手掌就威力无比了。</p>
<p>PS：在这部分我们看到了很多Java相关的技术，包括MVC(模型model－视图view－控制器controller)框架、hibernate、Spring、搜索引擎技术、IOE等；同时看到了遇到的一个接一个的问题及当时的解决方案。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTI2MTA5NjI=.jpg"></p>
<h2>三.&nbsp;坚若磐石&nbsp;缓存和CDN</h2>
<p>已经有读者在迫不及待地想知道怎么去掉IOE了？别急，在去掉IOE之前还有很长的路要走。</p>
<p>行癫等人买回小型机之后，我们用上了Oracle；然后七公带着一帮DBA做优化SQL和存储方面的工作，行癫带着几个架构师研究数据库的扩展性。Oracle本身是一个封闭的系统，用Oracle怎么做扩展呢？用现在一个时髦的说法就是“分库分表”。</p>
<p>我们知道一台Oracle的处理能力是由上限的，它的连接池有数量限制，查询速度和容量成反比。简单地说，在数据量上亿、查询量上亿的时候，就到它的极限了。要突破这种极限，最简单的方式就是多用几个Oracle数据库。</p>
<p>但一个封闭的系统做扩展，不像分布式系统那样直接加机器就可以了。我们的做法是把用户的信息按照ID来存放到两个数据库中（DB1和DB2），把商品的信息和卖家信息放在两个对立的数据库中，把商品类目等通用信息放在第三个库中（DBcommon）。这么做的目的除了增加了数据库的容量之外，还有一个就是做容灾，即万一一个数据库挂了，整个网站上还有一半的商品可以买。</p>
<p>数据库这么分后，应用程序就会出现麻烦，如果我是卖家，查看我的商品没有问题，我们都在一个库里。但如果我是一个买家，买的商品有DB1的，也有DB2的，要查看“我已买到的宝贝”的时候，应用程序怎么办？必须到两个数据库中分别查询对应的商品。要按时间排序怎么办？两个库中“我已买到的宝贝”全部查出来在应用程序中做合并。另外，分页怎么处理？关键字查询怎么处理？专业点的说法就是数据的Join没法做了。这些工作交给程序员来做也许会更麻烦，于是行癫出手了，他写了一个数据库路由的框架DBRoute，统一处理了数据的合并、排序、分页等操作，让程序员像使用一个数据库一样操作多个数据库里的数据，这个框架在淘宝的Oracle时代一直在使用。</p>
<p>但是后来随着业务的发展，这种分库的第二目的——“荣灾”的效果没有达到（数据库挂了，整个网站上还有一半的商品可以买）。像评价、投诉、举报、收藏、我的淘宝等很多地方，都必须同时连接DB1和DB2，哪个库挂了都会导致整个网站挂掉。</p>
<p>PS：讲到这里涉及到了很多数据库方面的知识，如“XXX管理系统”这样的网站大家一定都不陌生，数据库的增删改查，JSP\PHP\ASP结合数据库的这些网站都是很常见的课程项目或毕业设计。回过头来，这些东西都不是很难；如果让你去解决一个真实的网站中遇到的问题、去实现这样一个框架解决实际问题，那才是真正的厉害。同时说到数据库，你可能会想到包括数据的增删改查、各种交叉查询、Join操作、ACID特性、事务加锁、存储过程触发器等知识。</p>
<p>上一篇说过，采用EJB其实是和Sun的工程师妥协的结果，在他们离开后，EJB也逐渐冷落下来。在2005年和2006年的时候，Spring大放异彩，于是控制层用Spring替换掉了EJB，给整个系统精简了很多代码。</p>
<p>同时为了减少数据库的压力，提高搜索的效率，我们引入了搜索引擎。随着数据量的增长，到了2005年，商品数有1663万个，PV有8931万个，注册会员有1390万个，这给数据存储带来的压力依然很大，数据量大，速度就慢。亲，除了搜索引擎、分库分表，还有什么办法能提升系统的性能？一定还有招数，这就是缓存和CDN（内容分发网络）。</p>
<p>你可以想象9000万次的访问量，有多少是在商品详情页面？访问这个页面的时候，数据全都是只读的（全部从数据库中读出来，不写入数据库），在那个时候，我们的架构师多隆大神做了一个基于Berkeley<br />
 DB的缓存系统，把很多不太变动的只读信息放了进去。</p>
<p>其实最初这个缓存系统还比较弱，我们并不敢把所有能缓存的信息都往里面放，一开始先把卖家的信息放里面，然后把商品属性放里面，再把店铺信息放里面，但是像商品详情这类字段太大的放进去受不了。说到商品详情，这个字段比较恐怖，有人统计过，淘宝商品详情打印出来平均有5米长。笔者记得，我来淘宝之后担任项目经理做的第一个项目就是把商品详情从商品表中移除来，它最早与商品价&#26684;、运费等信息放在一个表中，拖慢了整张表的查询速度，而很多查询商品信息是不需要查看详情的。</p>
<p>于是在2005年的时候，我把商品详情放在数据库的另外一张表中，再往后，这个大字段被从数据库中请了出来，先是放入缓存系统，到现在放进了文件系统TFS（Taobao File System）中。</p>
<p>到现在为止，整个商品详情的页面都在缓存里面了，&#30524;尖的读者可能会发现现在的商品详情不全是“只读”的信息了，这个页面上有个信息叫“浏览量”（2006年加上去的），这个数字每刷新一次，页面就要“写入”存储一次，这种高频度实时更新的数据能用缓存吗？</p>
<p>通常来说，这种是必须放进数据库的，但悲剧的是，我们在2006年开发这个功能的时候，把浏览量写入数据库，发布上线1个小时后，数据库就挂掉了，每天几亿次的写入，数据库承受不了。那怎么办？亲，先不回答你，下一篇讲到缓存Tair的时候再说。</p>
<p>注意下图不是广告，请把注意力从左边移到右边，看看浏览量这个数据在哪里。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTM2MTUxOTE=.jpg"></p>
<p>PS：写到这里我想到了一个问题，大家都知道淘宝有一个买家评价和销售量可以推荐更好的商品；但是如果有浏览量呢？商家可以通过不断的刷新增加浏览量。就像CSDN博客一样，如果想通过Python写个简单的不断访问增加访问量的程序还是很容易的，如何防止这种问题呢？这个问题好像还挺有趣的。</p>
<p>CDN这个工作相对比较独立，跟别的系统一样，一开始我们采用的也是商用系统。后来随着流量的增加，商用的系统已经撑不住了，LVS的创始人章文嵩博士带人搭建了淘宝自己的CDN网络。在本文引言中说过淘宝网的CDN系统支撑了800Gbps以上的流量，作为对比，我们可以看下国内专业做CDN的上市公司ChinaCache的介绍（ChinaCache是中国第一的专业CDN服务提供商，向客户提供全方位网络内容快速分布解决方案。目前在全国50多个大中型城市拥有300多个节点，全网处理能力超过500Gbps，其CDN网络覆盖中国电信、网通、移动、联通、铁通、教育网科研网等各大运营商）：</p>
<p>淘宝一家的流量比他们的加起来还要多。</p>
<p>这样你可以看出淘宝在CDN上的实例，这在全世界都是数一数二的。另外因为CDN需要大量的服务器，要消耗很多资源（消耗多少？在前两年我们算过一笔账，淘宝上产生一个交易，消耗的电量足以煮熟4个鸡蛋）。这两年，章文嵩的团队又在研究低功耗的服务器。</p>
<p>我们对数据库分库、放弃EJB、引入Spring、加入缓存和CDN等工作，看起来没有章法可循，其实都是围绕着提高容量、提高性能、节约成本做的，由于这些是不算大的版本变迁，我们姑且叫它2.1版，这个版本从构图上看有三只脚，是不是稳定了很多？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTQ0MTU3NTA=.jpg"></p>
<p>在这个稳定的版本下，淘宝网发展迅猛，2005年5月微软的MSN门户大张旗鼓地进入中国，淘宝网成为它的购物频道。2005年盛大进军机顶盒业务，其电视购物的功能也是淘宝网开发的。虽然因水土不服或政策的原因，这两个业务现在都看不到了，但是他们曾经是中国互联网行业的大事件。</p>
<p>另外老马也从来不缺少娱乐精神，他看到湖南卫视的超女如此成功，也想借鉴这种模式。2005年底，淘宝网和湖南卫视合作推出“超级Buyer秀”，让大家分享自己的网购经历。虽然没有超女火爆，但也让“淘宝网就是网购”的形象加深人心。</p>
<p>到2006年，淘宝网已经有了1.5亿个日均PV，商品数达到5千万个，注册用户3千万个，全网成交额达169亿元。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTQ5NDM1OTE=.jpg"></p>
<p>最后回顾下这四张图的变迁和几个版本：</p>
<p>1.0版的PHP系统运行了将近一年的时间（2003年5月-2004年1月），服务器由1台发展到多台；</p>
<p>后来数据库撑不住了，将MySQL换成了Oracle，引入了搜索引擎（2004年1月-2004年5月），叫1.1版本；</p>
<p>然后不到半年的时间又把开发语言换成了Java（2004年2月-2005年3月），叫2.0版本，数据服务逐步采用了IOE（IBM小型机、Oracle、EMC存储）；</p>
<p>随着数据量和访问量的增长，我们进行数据分库、加入缓存、使用CDN（2004年10月-2007年1月），叫2.1版本。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjIxNTUyMTAwOTE=.jpg"></p>
<p>这几个版本中间有些时间上的重合，因为很多架构的演化并没有明显的时间点，它是逐步进化而来的。在描述2.1版本时，我写的标题是《坚若磐石》，因为这个版本终于稳定下来了，它在淘宝网运行了两年多的时间。这期间很多优秀的人才加入，也开发了很多优秀的产品，例如商品的类目属性、支付宝认证系统、招财进宝项目、淘宝旅游、淘宝彩票、淘宝论坛等，甚至在团购网站风起云涌之前，淘宝网在2006年就推出了“团购”的功能。</p>
<p>下一篇将讲述创造技术，包括TFS、Tair、缓存技术。</p>
<p>PS：最后还是希望文章对大家有所帮助，虽然文章中出现的很多涉及淘宝网的专业词汇我也不知道其技术是什么，但是还是能从《淘宝技术这十年 著：子柳》书中学到一些有用的知识。我主要是记录了其中自己认为比较好的文字复述出来，希望大家购买正版书籍阅读学习！</p>
<p>（By:Eastmount 2015-4-22 下午4点 &nbsp;&nbsp;<a href="http://blog.csdn.net/eastmount/" rel="external nofollow noreferrer">http://blog.csdn.net/eastmount/</a>）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 02:15:02 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.biecuoliao.com/tag/%e8%af%bb%e4%b9%a6%e7%ac%94%e8%ae%b0/" title="读书笔记">读书笔记</a>, <a href="https://www.biecuoliao.com/tag/%e6%90%9c%e7%b4%a2%e5%bc%95%e6%93%8e/" title="搜索引擎">搜索引擎</a>, <a href="https://www.biecuoliao.com/tag/java%e6%8a%80%e6%9c%af/" title="java技术">java技术</a>, <a href="https://www.biecuoliao.com/tag/%e6%b7%98%e5%ae%9d%e6%8a%80%e6%9c%af/" title="淘宝技术">淘宝技术</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>《淘宝技术这十年》读书笔记 (二).Java时代的脱胎换骨和坚若磐石的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzQWwl4.html" rel="bookmark">《淘宝技术这十年》读书笔记 &lpar;四&rpar;&period; 分布式时代和中间件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面两篇文章介绍了淘宝的发展历程.Java时代的变迁和淘宝开始创新技术: &lt;淘宝技术这十年&gt;读书笔记 (一).淘宝网技术简介及来源 &lt;淘宝技术这十年&gt;读书笔记 (二).Java时代的脱胎换骨和坚若磐石 &lt;淘宝技术这十年&gt;读书笔记 (三).创造技术TFS和Tair 这篇文章主要讲述分布式时代和中间件相关知识,包括服务化.HSF.Notify和TDDL.同时里面有我们经常遇见的编码错误等相关问题,希望文章对你有所帮助! 一. 分布式时代 1.服务化 在系统发展的过程中,架构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGpkab0.html" rel="bookmark">《淘宝技术这十年》读书笔记 &lpar;三&rpar;&period; 创造技术TFS和Tair</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面两篇文章介绍了淘宝的发展历程和Java时代的变迁: &lt;淘宝技术这十年&gt;读书笔记 (一).淘宝网技术简介及来源 &lt;淘宝技术这十年&gt;读书笔记 (二).Java时代的脱胎换骨和坚若磐石 马云说过&quot;创新不是为了与对手竞争,而是跟明天竞争&quot;,所以这篇文章讲述淘宝的创新技术TFS和Tair及创新的产品. 该篇文章不仅仅对在读大学生非常有所帮助,因为你能从文章中看到很多你需要学习的知识,不仅仅包括数据库.计算机网络.操作系统.数据结构等基础课程:还根据时代的技术变迁讲述了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yq1lO0.html" rel="bookmark">《淘宝技术这十年》读书笔记 &lpar;一&rpar;&period;淘宝网技术简介及来源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我似乎是2007年初中看&lt;赢在中国&gt;的时候喜欢上马云的,当时对电脑都不是很了解,更别提阿里巴巴和淘宝网了.但当时还是被马云的几句点评深深地吸引,其中我印象最深的一句话就是&quot;短暂的激情是不值钱的,只有长久的激情才是值钱的&quot;,以至于我在本科毕业德育答辩时用的题目就是这句话(德育答辩开题我用的题目也是马云的&lt;If not now,when? If not me,who?&gt;其含义是如果不是现在努力,什么时候努力呢?如果不是为了自己奋斗,又是为谁奋斗呢?).的确,想做成任			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myzyap0.html" rel="bookmark">《淘宝技术这十年》重读笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				序:&lt;淘宝技术这十年&gt;这本书在加入阿里之前就读过了,那时是以一种“仰视”的心态去读这本书,对书中描述的技术十分着迷(虽然不是全懂,但是感觉好厉害的样子).如今再回过头重读这本书,里面每一个技术要点,可能都是如今实际工作中会碰到的问题.于是我抱着重新梳理和整理的心态,再次阅读这部名著. 第0章:光棍节的狂欢 1.&lt;你刚才在淘宝上买了一件东西&gt;:打开域名=&gt;查询DNS(负载均衡)=&gt;找到入口IP=&gt;打开首页(负载均衡LVS)=&gt;多域名加载静态资源(CDN)=&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moa2Gk3.html" rel="bookmark">淘宝技术这十年-脱胎换骨的升级一一更换开发语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				到2004年上半年,淘宝网已经运行了一年的时间,这一年 积累了大量的用户,也快速开发了很多功能,当时这个网站已 经很庞大了,而且新的需求还在源源不断地增加.把一个庞大 的网站的开发语言换掉,无异于脱胎换骨,在换的过程中还不 能拖慢业务的发展,这无异于边换边跑,对时间和技术能力的 要求都非常高.做这样的手术,需要请第一流的专家来主刀. 现在再考一下 大家:亲,如果你在这个创业团队中, ì青什么样的人来做这件 事?我们的答案是请Sun公司的人.没错,就是创造Java语言的那 家公司,世界上没有比他们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xBmVQ4.html" rel="bookmark">20、淘宝技术这十年</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				淘宝技术这十年 淘宝技术这十年 作者介绍 子柳:本名赵超,2004年加入淘宝网,取花名子柳.历任开发工程师.项目经理.产品经理.测试经 理,2009年随着淘宝系统的大规模重构和人才的迅速扩张,创办了“淘宝技术大学”,培养内外部工 程师众多,人称“校长”.2011年将培训中的内容写成文章发表,遂一发不可收拾,总结了淘宝十年 的技术之路,乃成本书. 子柳 子柳,中国春秋时期鲁国政治人物,叔牙玄孙,武仲休曾孙,叔仲惠伯之孙. 叔仲皮生子柳.叔仲皮死,子柳之妻鲁人,丧服斩衰,头上用缪绖.叔仲衍请改成穗衰			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/382mEZM.html" rel="bookmark">《淘宝技术这十年》读书笔记&mdash;&mdash;第一章 第二章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 ? ? 这本书的作者是子柳先生,子柳本名赵超,2004年加入淘宝网.历任开发工程师.项目经理.产品经理.测试经理,2009年随着淘宝系统的大规模重构和人才的迅速扩张,创办了&quot;淘宝技术大学&quot;,因培养内外部工程师众多,人称&quot;校长&quot;. ? ? 之所以读这本书,主要想了解淘宝的技术/业务发展过程中遇到过哪些问题,以及他们怎么解决的.在阅读的过程中有很多不懂的地方,主要是知识面确实涵盖的太广,就当拓展视野吧. ? ? 第一章 ? ? 淘宝架构初版 ? ? 淘宝的第一版源			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qvabp4.html" rel="bookmark">《淘宝技术这十年》阅读笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一本不错的书,主要讲述了淘宝网的成长历史. 书分三部分: 第一部分讲了淘宝的成长史: 第二部分讲淘宝使用的一些创新技术: 这部分中作者的7年经历挺有意思的,菜鸟开发,项目经理,产品经理,测试经理,淘宝技术大学校长,每个阶段的心理历程很真实. 第三部分讲了一些阿里中一些牛人的经历. 摘抄一些语句: 纯粹的技术人才,如果找不到互补的伙伴,加入一个大公司,也不失为一个好的选择: 晋升是看你对公司有哪些贡献,而不是看你的技术有多么牛: 做事要先思考再问人,不断打破自己的一些想法 : 任何一个公司,都无法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBDLrK3.html" rel="bookmark">淘宝技术这十年 第七章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				? ? 正明 ? ? ? ? ? ? 博士期间开发了开源LVS,2000~2006年在国防科大教书:08年进淘宝,做LVS+HAproxy的普及,现在负责CDN系统的改良工作 : ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? 毕玄 06年加入淘宝,负责淘宝的高性能服务框架,著作&lt;OSGi原理与最佳实践&gt;,推广OSGi在中国的应用: ? ? ? ? 看看他的每日时间分配:代码3小时.剩下来很多时间看技术文章或图书,每隔一段时间跳出来想想将来干什么好: ? ? 作为淘宝晋			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoBy4Z.html" rel="bookmark" class="title">Java的成员变量初始化</a>
					<div>
						对于方法里面的成员变量,Java要求程序员强制提供一个初始化的值.比如下面这个方法就会出错: public class Breakyizhan{ public void Z(){ int z; z++ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jgqE3.html" rel="bookmark" class="title">python第十九天&mdash;&mdash;感冒中</a>
					<div>
						ConfigParser模块,hashlib模块,hmac模块: 创建配置文件: 1 import configparser 2 3 config = configparser.ConfigParse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lAlb3.html" rel="bookmark" class="title">a标签的link，visited，hover，active分别是什么</a>
					<div>
						a:link {color: #FF0000} /*未访问状态*/ a:visited {color: #00FF00}/*已访问状态*/ a:hover {color: #FF00FF}/*鼠标移入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZeDe3.html" rel="bookmark" class="title">ArrayList源码解析（一）</a>
					<div>
						目录 1.位置 2.变量和常量 3.构造函数 4.trimToSize()方法 正文 源码解析系列主要对Java的源码进行详细的说明,由于水平有限,难免出现错误或描述不准确的地方,还请大家指出. 回到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8nPa0.html" rel="bookmark" class="title">判断一个字符串中出现次数最多的字符，统计这个次数</a>
					<div>
						var str='adedbjaaafdfdlfdfadsdaaaadfjfaaaaadkkfaaa'; var json={}; for(var i=0; i&lt;str.length; i++) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0en1aJ3.html" rel="bookmark" class="title">&num;HTTP协议学习&num; （十二）理解转发与重定向</a>
					<div>
						本文转自:http://blog.csdn.net/meiyalei/article/details/2129120  生动清晰 解释一 转发是服务器行为,重定向是客户端行为.为什么这样说呢,这就要看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDwR74.html" rel="bookmark" class="title">求解非线性方程的的最优化算法C&plus;&plus;程序</a>
					<div>
						http://www.saige.com/shop/list-2008104.htmhttp://www.saige.com/shop/list-2008108.htmhttp://www.saige ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBAG9M.html" rel="bookmark" class="title">Spark学习</a>
					<div>
						mapreduce RDD 流程示意 Yarn					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWLWjm0.html" rel="bookmark" class="title">DHCP的搭建</a>
					<div>
						系统 环境: [[email protected] ~]# cat /etc/redhat-release CentOS Linux release 7.2.1511 (Core) [[email p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylPdp4.html" rel="bookmark" class="title">中国南北方文化差异分析比较</a>
					<div>
						南北方妹子的差别,你都造咩? 小编妹纸个人微信:mengqi553,欢迎添加 1. 身高都知道的,南方和北方人的平均身高是有差距的.北方女生要高些,大概在165~173之间.我有一个女性朋友身高在16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZGvp0.html" rel="bookmark" class="title">CreateWindowEx和CreateWindow的区别</a>
					<div>
						CreateWindowEx 函数功能:该函数创建一个具有扩展风格的重叠式窗口.弹出式窗口或子窗口,其他与 CreateWindow函数相同.关于创建窗口和其他参数的内容,请参看CreateWindo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbgdjM.html" rel="bookmark" class="title">java mysql大数据量批量插入与流式读取分析</a>
					<div>
						总结下这周帮助客户解决报表生成操作的mysql 驱动的使用上的一些问题,与解决方案.由于生成报表逻辑要从数据库读取大量数据并在内存中加工处理后在 生成大量的汇总数据然后写入到数据库.基本流程是 读取- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NnmZ84.html" rel="bookmark" class="title">android短信发送器源代码</a>
					<div>
						Activity类: import java.util.List;import android.app.Activity;import android.app.PendingIntent;import ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rEVK4.html" rel="bookmark" class="title">Javascript中&amp;amp&semi;&amp;amp&semi;和&amp;amp&semi;，&vert;&vert;和&vert;运算符两个不同点</a>
					<div>
						1.性能上的比较 如果&amp;&amp;的第一个运算数是false,就不再考虑第二个运算数,直接返回false:如 果||的第一个运算数是true,也不再考虑第二个运算数,直接返回true.&amp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6oAD0.html" rel="bookmark" class="title">VirtualBox &plus; CentOS 虚拟机网卡配置</a>
					<div>
						摘要: 要学好Linux,还是得自己搭建虚拟机. VirtualBox比较小巧简单,容易上手.在配合CentOS 6.4使用时,首要的问题就是网卡配置,尤其是使用SSH终端仿真程序(例如SecureC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRA6X0.html" rel="bookmark" class="title">thinkphp中session 判断</a>
					<div>
						session判断 要判断一个session值是否已经设置,可以使用 session('?name'); 用于判断名称为name的session值是否已经设置相当于: isset($_SESSION[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6pGKZ3.html" rel="bookmark" class="title">比较好的iOS的博客</a>
					<div>
						王巍的博客:http://onevcat.com池建强的博客: http://macshuo.com唐巧的博客:http://blog.devtang.com许小帅的博客:http://imallen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47exGk0.html" rel="bookmark" class="title">Boss OpenCart 商城自适应主题模板 ABC-0012-01</a>
					<div>
						Boss OpenCart 商城自适应主题模板 ABC-0012-01 模板特性兼容浏览器IE7, IE8, IE9, IE10, Firefox, Safari, ChromeOpenCart版本O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynwRL0.html" rel="bookmark" class="title">网站整站变灰</a>
					<div>
						&lt;style rel=&quot;stylesheet&quot;&gt; html{ -webkit-filter: grayscale(100%); -moz-filter: graysca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AxpAZ3.html" rel="bookmark" class="title">VirtualBox后台运行虚拟机（无图形界面启动虚拟机）</a>
					<div>
						有时候可能会用虚拟机搭建集群,这是通常希望不现实图形界面,试了半天,似乎只有Virtual Box支持无图形界面运行虚拟机,方法如下: 在Virtual Box的安装目录中找到VBoxManage,M ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
